      MODULE s_GPHECM
      CONTAINS

C*
      SUBROUTINE GPHECM(FILPHS,PECMOD)
CC
CC NAME       :  GPHECM
CC
CC PURPOSE    :  READ MODEL NAME OF THE PHASE ECCENTRICITY FILE
CC               IF NO MODEL NAME IS FOUND A BLANK IS RETURNED
CC
CC PARAMETERS :
CC         IN :  FILPHS : FILENAME OF PHASE FILE              CH*32
CC        OUT :  PECMOD : PHASE ECCENTRICITY MODEL            I*4
CC
CC REMARKS    :  ---
CC
CC AUTHOR     :  E.BROCKMANN
CC
CC VERSION    :  4.1
CC
CC CREATED    :  11-JUL-96
CC
CC CHANGES    :  11-JUL-96 : EB: START
CC               08-MAR-04 : HU: CLOSE FILE
CC               21-JUN-05 : MM: COMLFNUM.inc REMOVED, m_bern ADDED
CC               23-JUN-05 : MM: IMPLICIT NONE AND DECLARATIONS ADDED
CC
CC COPYRIGHT  :  ASTRONOMICAL INSTITUTE
CC      1996     UNIVERSITY OF BERN
CC               SWITZERLAND
CC
C*
      USE m_bern
      USE s_opnfil
      USE s_opnerr
      USE s_gtflna
      IMPLICIT NONE
C
C DECLARATIONS INSTEAD OF IMPLICIT
C --------------------------------
      INTEGER*4 IOSTAT, IRC
C
CCC       IMPLICIT REAL*8 (A-H,O-Z)
      CHARACTER*32 FILPHS
      CHARACTER*22 STRHLP
      CHARACTER*10 PECMOD
C
C INITIALISATION
C --------------
      PECMOD=' '
C
C DO NOT SAVE IF NO COORDINATE RESULT FILE NAME IN FILE NAME TABLE
C ----------------------------------------------------------------
      IF (FILPHS.EQ.' ') THEN
        CALL GTFLNA(0,'PHASECC',FILPHS,IRC)
        IF(IRC.NE.0) RETURN
      ENDIF
      IF (FILPHS.EQ.' ') RETURN
C
      CALL OPNFIL(LFNLOC,FILPHS,'OLD','FORMATTED',
     1            'READONLY',' ',IOSTAT)
      CALL OPNERR(LFNERR,LFNLOC,IOSTAT,FILPHS,'GPHECM')
C
C READ MODEL NAME (DIRECTLY IN THE FIRST LINE OF THE FILE)
C E.G. MODEL NAME: IGS_01....
C --------------------------------------------------------
      READ(LFNLOC,11)STRHLP
11    FORMAT(A22)
      IF (STRHLP(1:10).EQ.'MODEL NAME') THEN
        READ(STRHLP,'(12X,A10)')PECMOD
      ENDIF
      CLOSE (LFNLOC)
C
      RETURN
      END SUBROUTINE

      END MODULE
