      MODULE s_INIEPO
      CONTAINS

C*
      SUBROUTINE INIEPO(MAXSAS,MAXFLS,SYNFLG,ELEVA,LOCQ)
CC
CC NAME       :  INIEPO
CC
CC PURPOSE    :  INITIALIZE EPOCH PROCESSING FOR PROGRAM GPSEST
CC
CC PARAMETERS :
CC         IN :  MAXSAS : MAXIMUM NUMBER OF SAT./EPOCH        I*4
CC               MAXFLS : MAXIMUM NUMBER OF FILES             I*4
CC        OUT :  SYNFLG(K),K=1,..,MAXFLS:                     CH*1
CC                        SYNCHRONIZATION FLAG
CC               ELEVA(2,I),I=1,..,NSASES: ELEVATIONS FOR     R*8
CC                        MAX. TWO SITES
CC               LOCQ(K,I),K=1,..,MAXLCQ, I=1,..,NPAR:        I*4
CC                        PARAMETER DESCRIPTOR
CC
CC REMARKS    :  ---
CC
CC AUTHOR     :  G.BEUTLER
CC
CC VERSION    :  3.4  (JAN 93)
CC
CC CREATED    :  87/10/20 17:21
CC
CC CHANGES    :  29-JAN-97 : SS: "ELEVA" AS TWO-DIM. ARRAY,
CC                               REMOVE "MAXSAT" FROM PARAM.LIST
CC               21-JAN-98 : SS: TIME-CONSUMING INITIALIZATION OF
CC                               "ASING" AND "INDSNG" REMOVED
CC               25-OCT-00 : RD: COUNT OBS. FOR CLOCKS
CC               22-NOV-00 : TS: REMOVE LOCQ INITIALIZATION (NOT NEEDED?)
CC               17-FEB-03 : LM: USE P_GPSEST
CC               08-MAR-03 : MR: MAXAMB MOVED TO M_MAXDIM
CC               28-JUN-04 : RD: REMOVE DISPENSABLE PARAMETERS
CC               23-JUN-05 : MM: IMPLICIT NONE AND DECLARATIONS ADDED
CC
CC COPYRIGHT  :  ASTRONOMICAL INSTITUTE
CC      1987     UNIVERSITY OF BERN
CC               SWITZERLAND
CC
C*
      USE p_gpsest, ONLY: MAXLCQ
      IMPLICIT NONE
C
C DECLARATIONS INSTEAD OF IMPLICIT
C --------------------------------
      INTEGER*4 I     , K     , MAXFLS, MAXSAS
C
CCC       IMPLICIT REAL*8 (A-H,O-Z)
CCC       IMPLICIT INTEGER*4 (I-N)
C
C
      CHARACTER*1  SYNFLG(*)
C
      INTEGER*4    LOCQ(MAXLCQ,*)
C
      REAL*8       ELEVA(2,*)
C
C INITIALIZE ELEVA
      DO 15 I=1,MAXSAS
        DO 10 K=1,2
          ELEVA(K,I)=0.D0
10      CONTINUE
15    CONTINUE
C
C INITIALIZE SYNFLG
      DO 20 I=1,MAXFLS
        SYNFLG(I)='U'
20    CONTINUE
C
C INITIALIZE COUNTER FOR SAT:/STA. CLOCKS
C      DO 30 IPAR=1,MAXPAR
C        IF ((LOCQ(1,IPAR).EQ.23) .OR. (LOCQ(1,IPAR).EQ.24))
C     1     LOCQ(6,IPAR)=0
C30    CONTINUE
C
      RETURN
      END SUBROUTINE

      END MODULE
