      MODULE s_iordup
      CONTAINS

C*
      SUBROUTINE IORDUP(X,N,INDEX)
CC
CC NAME       : IORDUP
CC
CC PURPOSE    : PUTS THE N FIRST ELEMENTS OF A VECTOR X
CC              IN ASCENDING ORDER IN THE FOLLOWING MANNER:
CC              THE INDEX OF THE LOWEST ELEMENT IS STORED
CC              IN INDEX(1), THE INDEX OF THE SECOND LOWEST
CC              ELEMENT IS STORED IN INDEX(2) AND SO ON.
CC              THE VECTOR X IS NOT CHANGED.
CC
CC PARAMETERS :
CC         IN : X       : VECTOR                  I*4
CC              N       : NUMBER OF ELEMENTS      I*4
CC
CC        OUT : INDEX   : VECTOR (WITH INDICES)   I*4
CC
CC RESTRICTION: NONE
CC
CC AUTHOR     :
CC              ASTRONOMICAL INSTITUTE, UNIVERSITY OF BERN
CC              SWITZERLAND
CC
CC CREATED    :  ??-???-??
CC
CC CHANGES    :  13-MAY-03 : AJ: NEW DECLARATION FOR X,INDEX
CC               23-JUN-05 : MM: IMPLICIT NONE AND DECLARATIONS
CC
C*
      IMPLICIT NONE
C
C DECLARATIONS INSTEAD OF IMPLICIT
C --------------------------------
      INTEGER*4 I     , IGRENZ, IMIN  , INDEX , J     , N     , X     ,
     1          XGRENZ, XMIN
C
CCC       IMPLICIT INTEGER*4 (A-Z)
      DIMENSION X(*),INDEX(*)
      IGRENZ=0
      XGRENZ=-2147483647
      DO 40 J=1,N
      XMIN=2147483647
      DO 20 I=1,N
      IF(X(I).LT.XGRENZ) GOTO 20
      IF(X(I).EQ.XGRENZ) GOTO 15
      IF(X(I).GE.XMIN)   GOTO 20
      XMIN=X(I)
      IMIN=I
      GOTO 20
15    IF(I.GT.IGRENZ) GOTO 25
20    CONTINUE
      GOTO 30
25    IMIN=I
30    INDEX(J)=IMIN
      XGRENZ=X(IMIN)
      IGRENZ=IMIN
40    CONTINUE
      RETURN
      END SUBROUTINE

      END MODULE
