      MODULE s_JECNST
      CONTAINS

C*
      SUBROUTINE JECNST(NAM,VAL,SSS,N)
CC
CC NAME       :  JECNST
CC
CC PURPOSE    :  THIS SUBROUTINE OBTAINS THE CONSTANTS FROM THE
CC               EPHEMERIS FILE
CC
CC PARAMETERS :
CC        OUT :  NAM    : ARRAY OF CONSTANT NAMES             CH*6
CC               VAL    : ARRAY OF VALUES OF CONSTANTS         R*8
CC               SSS    : JD START, JD STOP, STEP OF EPHEMERIS R*8
CC               N      : NUMBER OF ENTRIES IN 'NAM' AND       I*4
CC                        'VAL' ARRAYS
CC
CC REMARKS    :  THE ARRAYS 'NAM' AND 'VAL' MUST HAVE SUFFICIENTLY
CC               LARGE DIMESNIONS TO ACCOMMODATE ALL ENTRIES ON THE
CC               FILE. THE VALUE 400 IS A SAFE UPPER LIMIT FOR THIS
CC               DIMENSION.
CC
CC AUTHOR     :  JPL
CC
CC VERSION    :  3.4
CC
CC CREATED    :  22-OCT-92
CC
CC CHANGES    :  23-JUN-05 : MM: IMPLICIT NONE AND DECLARATIONS ADDED
CC
CC COPYRIGHT  :  NONE
CC      1992
CC
C*
      USE s_jeopen
      IMPLICIT NONE
C
C DECLARATIONS INSTEAD OF IMPLICIT
C --------------------------------
      INTEGER*4 I
C
      CHARACTER*6 NAM(*)
      REAL*8      VAL(*),SSS(3)
      INTEGER*4   N
C
C     COMMON AREA FOR CHARACTER DATA IN RECORD 1
C
      CHARACTER*6 TTL(14,3),CNAM(400)
      COMMON/CHRHDR/TTL,CNAM
C
C     COMMON AREA FOR CONSTANTS AND POINTERS IN RECORD 1
C
      REAL*8    SS(3),CVAL(400),AU,EMRAT
      INTEGER*4 NCON,IPT(36),DENUM,LPT(3)
      COMMON/EPHHDR/SS,CVAL,AU,EMRAT,NCON,IPT,DENUM,LPT
C
C
C     OPEN THE FILE AND READ RECORD 1
C
      CALL JEOPEN(.TRUE.)
C
C     COPY CORRECT DATA TO CALLING SEQUENCE VARIABLES
C
      N=NCON
      DO 1 I=1,3
        SSS(I)=SS(I)
1     CONTINUE
C
      DO 2 I=1,NCON
        NAM(I)=CNAM(I)
        VAL(I)=CVAL(I)
2     CONTINUE
C
      RETURN
C
      END SUBROUTINE

      END MODULE
