      MODULE f_modsvn
      CONTAINS

C*
      FUNCTION MODSVN(NUMSVN)
CC
CC NAME       :  MODSVN
CC
CC PURPOSE    :  RETURNS ORIGINAL SVN NUMBER FOR GPS AND GLONASS
CC               SATELLITES (SUBTRACT 50 FOR MANOEUVRE SATELLITES).
CC
CC PARAMETERS :
CC         IN :  NUMSVN : SATELLITE NUMBER (INCLUDING +50)    I*4
CC        OUT :  MODSVN : ORIGINAL SATELLITE NUMBER           I*4
CC
CC REMARKS    :  ---
CC
CC AUTHOR     :  M.ROTHACHER
CC
CC VERSION    :  4.1  (APR 97)
CC
CC CREATED    :  29-APR-97
CC
CC CHANGES    :  19-AUG-99 : HB: CHECK NUMSVN.LT.100 FOR LEOs
CC               23-JUN-05 : MM: IMPLICIT NONE AND DECLARATIONS ADDED
CC
CC COPYRIGHT  :  ASTRONOMICAL INSTITUTE
CC      1997     UNIVERSITY OF BERN
CC               SWITZERLAND
CC
C*
      IMPLICIT NONE
C
C DECLARATIONS INSTEAD OF IMPLICIT
C --------------------------------
      INTEGER*4 MODSVN, NUMSVN
C
      IF (MOD(NUMSVN,100).GT.50 .AND. NUMSVN.LT.900) THEN
        MODSVN=NUMSVN-50
      ELSE
        MODSVN=NUMSVN
      ENDIF
C
      RETURN
      END FUNCTION

      END MODULE
