      MODULE s_RANDU
      CONTAINS

C*
      SUBROUTINE RANDU(IX,IY,YFL)
CC
CC NAME       :  RANDU
CC
CC PURPOSE    :  GENERATE A RANDOM INTEGER NUMBER IY AND A
CC               FLOAT RANDOM NUMBER YFL FROM AN INPUT VARIABLE IX
CC               IY IS UNIFORMLY DISTRIBUTED IN (0,2**32-1)
CC               YFL IS UNIFORMLY DISTRIBUTED IN (0,1)
CC
CC
CC PARAMETERS :
CC         IN :  IX     : INPUT                               I*4
CC        OUT :  IY     : OUTPUT                              I*4
CC               YFL    : OUTPUT, FLOAT                       R*8
CC
CC REMARKS    :  TO GET A SERIES OF RANDOM NUMBERS SET IX=IY IN THE
CC               CALLING ROUTINE AFTER EACH CALL.
CC
CC AUTHOR     :  G.BEUTLER, M.ROTHACHER
CC
CC VERSION    :  3.4  (JAN 93)
CC
CC CREATED    :  88/02/26 08:22
CC
CC CHANGES    :  23-JUN-05 : MM: IMPLICIT NONE AND DECLARATIONS ADDED
CC               04-MAY-12 : RD: USE DMOD FROM MODULE
CC
CC COPYRIGHT  :  ASTRONOMICAL INSTITUTE
CC      1988     UNIVERSITY OF BERN
CC               SWITZERLAND
CC
C*
      USE l_basfun, ONLY: dmod
      IMPLICIT NONE
C
C DECLARATIONS INSTEAD OF IMPLICIT
C --------------------------------
      INTEGER*4 IX , IY
C
      REAL*8    Y  , YFL
C
CCC       IMPLICIT INTEGER*4(I-N)
CCC       IMPLICIT REAL*8 (A-H,O-Z)
C
C  MULTIPLY INPUT NUMBER BY 2**16+3
      Y=IX*65539.D0
C
C  MODULO 2**31
      Y=DMOD(Y,2147483648.D0)
      IY=IDNINT(Y)
C
C TRANSFORM VARIABLE INTO INTERVAL (0,1)
      YFL=Y/2147483648.D0
C
      RETURN
      END SUBROUTINE

      END MODULE
