      MODULE s_SHADOW
      CONTAINS

C*
      SUBROUTINE SHADOW(X,XSUN,IS)
CC
CC NAME       :  SHADOW
CC
CC PURPOSE    :  DECIDE WHETHER OR NOT A SPACE VEHICLE IS
CC               IN SUN LIGHT OR IN EARTH SHADOW
CC
CC PARAMETERS :
CC         IN :  X(I),I=1,2,3 ARE THE COORDINATES OF THE SATELLITE R*8
CC               XSUN(I),I=1,2,3 ARE THE COORDINATES OF THE SUN,   R*8
CC               XSUN(4)         IS THE DISTANCE GEOCENTER-SUN
CC        OUT :  IS = 0 : SATELLITE IN SUNLIGHT                    I*4
CC                  = 1 : SATELLITE IN EARTH-SHADOW
CC
CC
CC REMARKS    :  ---
CC
CC AUTHOR     :  G.BEUTLER, M.ROTHACHER
CC
CC VERSION    :  3.4  (JAN 93)
CC
CC CREATED    :  87/11/30 08:11
CC
CC CHANGES    :  23-JUN-05 : MM: IMPLICIT NONE AND DECLARATIONS ADDED
CC
CC COPYRIGHT  :  ASTRONOMICAL INSTITUTE
CC      1987     UNIVERSITY OF BERN
CC               SWITZERLAND
CC
C*
      IMPLICIT NONE
C
C DECLARATIONS INSTEAD OF IMPLICIT
C --------------------------------
      INTEGER*4 IS  , K
C
      REAL*8    R   , SC  , TEST
C
CCC       IMPLICIT REAL*8 (A-H,O-Z)
      REAL*8 X(*),XSUN(*)
C
      R=0.D0
      SC=0.D0
      DO 2 K=1,3
      SC=SC+X(K)*XSUN(K)
      R =R +X(K)*X(K)
2     CONTINUE
      R=DSQRT(R)
      SC=SC/(R*XSUN(4))
      TEST=R*DSQRT(1.D0-SC**2)
      IS=0
      IF(TEST.LT.6367395.1D0.AND.SC.LT.0.D0)IS=1
      RETURN
      END SUBROUTINE

      END MODULE
