      MODULE s_SININI
      CONTAINS

C*
      SUBROUTINE SININI(AGENCY,DATOWN)
CC
CC NAME       :  SININI
CC
CC PURPOSE    :  READ INPUT OPTIONS FOR SAVING A SINEX FILE
CC
CC PARAMETERS :
CC        OUT :  AGENCY : AGENCY 3-CHAR ABBREVIATION          CH*3
CC               DATOWN : OWNER OD DATA 3-CHAR ABBREVIATION   CH*3
CC
CC
CC REMARKS    :  ---
CC
CC AUTHOR     :  E.BROCKMANN
CC
CC VERSION    :  3.4  (JAN 93)
CC
CC CREATED    :  30-MAY-95
CC
CC CHANGES    :  30-MAY-95 : EB: CREATION DATE
CC               21-JUN-05 : MM: COMLFNUM.inc REMOVED, m_bern ADDED
CC               23-JUN-05 : MM: IMPLICIT NONE AND DECLARATIONS ADDED
CC
CC COPYRIGHT  :  ASTRONOMICAL INSTITUTE
CC      1989     UNIVERSITY OF BERN
CC               SWITZERLAND
CC
C*
      USE m_bern
      USE s_opnfil
      USE s_opnerr
      USE s_gtflna
      IMPLICIT NONE
C
C DECLARATIONS INSTEAD OF IMPLICIT
C --------------------------------
      INTEGER*4 IOSTAT, IRC
C
CCC       IMPLICIT REAL*8(A-H,O-Z)
C

      CHARACTER*32 FILNAM
      CHARACTER*3  AGENCY,DATOWN
C
C
C OPEN INPUT FILE
C ---------------
      CALL GTFLNA(0,'SINEXIN',FILNAM,IRC)
      IF (IRC.NE.0) THEN
        WRITE(LFNERR,901)
901     FORMAT(/,' *** SR SININI: WARNING: NO ENTRY OF -SINEXIN- FOUND',
     1           ' IN N-FILE!',
     2     /,16X,'SOME SETTINGS ARE SET TO UNKNOWN (---)',/)
      ELSE
        CALL OPNFIL(LFNLOC,FILNAM,'OLD','FORMATTED',
     1            'READONLY',' ',IOSTAT)
        CALL OPNERR(LFNERR,LFNLOC,IOSTAT,FILNAM,'SININI')
      ENDIF
C
C INITIALISATION IF INPUT FILE FILE NOT FOUND
C
      AGENCY='---'
      DATOWN='---'
C
C READ TITLE
C ----------
      IF (IRC.EQ.0.AND.IOSTAT.EQ.0) THEN
        READ(LFNLOC,11)AGENCY,DATOWN
11      FORMAT(////////,7X,A3,7(/),7X,A3,//)
        CLOSE(UNIT=LFNLOC)
      ENDIF
C
      RETURN
      END SUBROUTINE

      END MODULE
