      MODULE s_TMIDLE
      CONTAINS

C*
      SUBROUTINE TMIDLE(NFTOT,NEPOCH,IDELTT,TIMREF,WINDOW,TIMMID)
CC
CC NAME       :  TMIDLE
CC
CC PURPOSE    :  COMPUTE MIDDLE OF TIME INTERVALS FOR NFTOT FILES
CC
CC PARAMETERS :
CC         IN :  NFTOT  : TOTAL NUMBER OF FILES               I*4
CC               NEPOCH(I),I=1,..: NUMBER OF EPOCHS IN FILE   I*4
CC               IDELTT(I),I=... : TABLE INTERVAL IN SEC      I*4
CC               TIMREF(I),I=... : REFERENCE TIME OF FILE     R*8
CC               WINDOW : TIME WINDOW                         R*8(2,*)
CC        OUT :  TIMMID(I),I=1,..: MIDDLE OF TIME INTERVAL    R*8
CC
CC REMARKS    :  ---
CC
CC AUTHOR     :  M.ROTHACHER
CC
CC VERSION    :  3.4  (JAN 94)
CC
CC CREATED    :  07-APR-92
CC
CC CHANGES    :  19-NOV-04 : RD: CONSIDER OBSERVATION TIME WINDOW
CC               23-JUN-05 : MM: IMPLICIT NONE AND DECLARATIONS ADDED
CC
CC COPYRIGHT  :  ASTRONOMICAL INSTITUTE
CC      1992     UNIVERSITY OF BERN
CC               SWITZERLAND
CC
C*
      IMPLICIT NONE
C
C DECLARATIONS INSTEAD OF IMPLICIT
C --------------------------------
      INTEGER*4 IF    , NFTOT
C
      REAL*8    TFIRST, TLAST
C
CCC       IMPLICIT REAL*8 (A-H,O-Z)
C
      REAL*8     TIMREF(*),TIMMID(*),WINDOW(2,*)
C
      INTEGER*4  NEPOCH(*),IDELTT(*)
C
C LOOP OVER ALL FILES
C -------------------
      DO 100 IF=1,NFTOT
        IF (WINDOW(1,IF).NE.0d0.AND.WINDOW(1,IF).GT.TIMREF(IF)) THEN
          TFIRST=WINDOW(1,IF)
        ELSE
          TFIRST=TIMREF(IF)
        ENDIF
C
        TLAST =TIMREF(IF)+IDELTT(IF)/86400.D0*NEPOCH(IF)
        IF (WINDOW(2,IF).NE.1d20.AND.WINDOW(2,IF).LT.TLAST) THEN
          TLAST=WINDOW(2,IF)
        ENDIF
C
        TIMMID(IF)=(TFIRST+TLAST)/2d0
100   CONTINUE
C
      RETURN
      END SUBROUTINE

      END MODULE
