/* ------------------------------------------------------------------------
* Bernese GPS Software Version 5.1
* -------------------------------------------------------------------------
*
* Name:       menu.h
*
* Authors:
*
* Created:    __-___-____
* Last mod.:  25-Sep-2012
*
* Changes:    12-Nov-2010 SL: STA2STA added
*             15-Feb-2011 SL: STAMERGE added
*             25-Sep-2012 SL/RD: add menu item README
*
* Copyright:  Astronomical Institute
*             University of Bern
*             Switzerland
* -----------------------------------------------------------------------*/

#ifndef MENU_H
#define MENU_H

enum t_irc {success, failure}; // return code

enum MenuIDs
{
  MENU_ID_FONT_BASE = 1,
  MENU_ID_FONT_LARGE,
  MENU_ID_FONT_SMALL,
  MENU_ID_BUTTON_COLOR,
  MENU_ID_BCKGRD_COLOR,
  MENU_ID_FONT_RESET,

  MENU_ID_PROGRAMS,
  MENU_ID_PATHS,

  MENU_ID_CAMPLIST,
  MENU_ID_SELCAMP,
  MENU_ID_NEWCAMP,
  MENU_ID_SESSIONS,

  MENU_ID_EDITCRD,
  MENU_ID_EDSTACRX,
  MENU_ID_ABBREV,
  MENU_ID_EDITECC,
  MENU_ID_EDITVEL,
  MENU_ID_EDITFIX,
  MENU_ID_EDITSIG,
  MENU_ID_EDITCLU,
  MENU_ID_EDITSOS,
  MENU_ID_EDITBSL,
  MENU_ID_EDITPLD,

  MENU_ID_RXOBV3,
  MENU_ID_RXNBV3,
  MENU_ID_RXMBV3,
  MENU_ID_RXNPRE,
  MENU_ID_RNXGRA,
  MENU_ID_RNXSMT,
  MENU_ID_RNXCLK,
  MENU_ID_CCRNXC,
  MENU_ID_CCRINEXO,
  MENU_ID_CCRINEXN,
  MENU_ID_CCRINEXG,
  MENU_ID_BV3RXO,
  MENU_ID_BV3RXN,
  MENU_ID_SNX2NQ0,
  MENU_ID_SNX2STA,
  MENU_ID_TROTRO,
  MENU_ID_GPSSIM,

  MENU_ID_BRDTST,
  MENU_ID_PRETAB,
  MENU_ID_BRDTAB,
  MENU_ID_ORBGEN,
  MENU_ID_STDPRE,
  MENU_ID_PREWEI,
  MENU_ID_CCPREORB,
  MENU_ID_SATCLK,
  MENU_ID_STDELE,
  MENU_ID_STDDIF,
  MENU_ID_ORBCMP,

  MENU_ID_CODSPP,
  MENU_ID_SNGDIF,
  MENU_ID_MAUPRP,
  MENU_ID_GPSEST,
  MENU_ID_IONEST,
  MENU_ID_ADDNEQ,

  MENU_ID_CHGHED,
  MENU_ID_OBSHEAD,
  MENU_ID_OBSFILE,
  MENU_ID_SATMRK,
  MENU_ID_SATGRA,
  MENU_ID_OBSSPL,
  MENU_ID_AMBCHK,
  MENU_ID_ADDNEQPLT,
  MENU_ID_REDISP,
  MENU_ID_COMPAR,
  MENU_ID_FODITS,
  MENU_ID_GRDS1S2,
  MENU_ID_FMTOBS,
  MENU_ID_OBSFMT,
  MENU_ID_RESFMT,
  MENU_ID_FMTRES,
  MENU_ID_STDFMT,
  MENU_ID_FMTSTD,
  MENU_ID_NEQ2ASC,
  MENU_ID_DEFXTR,
  MENU_ID_CODXTR,
  MENU_ID_MPRXTR,
  MENU_ID_GPSXTR,
  MENU_ID_RESCHK,
  MENU_ID_CRDMRG,
  MENU_ID_COOVEL,
  MENU_ID_COOSYS,
  MENU_ID_RESRMS,
  MENU_ID_POLXTR,
  MENU_ID_POLUPD,
  MENU_ID_NUVELO,
  MENU_ID_VELDIF,
  MENU_ID_BASLST,
  MENU_ID_MKCLUS,
  MENU_ID_RNX2STA,
  MENU_ID_STA2STA,
  MENU_ID_STAMERGE,
  MENU_ID_HELMERT,
  MENU_ID_ETRS89,
  MENU_ID_ATX2PCV,
  MENU_ID_CLKEST,
  MENU_ID_LEOAUX,
  MENU_ID_KINPRE,
  MENU_ID_IRV2STV,
  MENU_ID_CPFSP3,
  MENU_ID_SP3CPF,
  MENU_ID_SNX2SLR,
  MENU_ID_QLRINEXO,
  MENU_ID_QLRSUM,
  MENU_ID_JOB,
  MENU_ID_ERRMSG,

  MENU_ID_JULDAT,
  MENU_ID_EDTPCF,
  MENU_ID_EDTPCF_NEW,
  MENU_ID_EDTCPU,
  MENU_ID_RESETCPU,
  MENU_ID_EDTBPE,
  MENU_ID_EDTINP,
  MENU_ID_UPDPAN,
  MENU_ID_CHNGEN,
  MENU_ID_VAR,
  MENU_ID_RUNBPE,

  MENU_ID_USER01,
  MENU_ID_USER02,
  MENU_ID_USER03,
  MENU_ID_USER04,
  MENU_ID_USER05,
  MENU_ID_USER06,
  MENU_ID_USER07,
  MENU_ID_USER08,
  MENU_ID_USER09,
  MENU_ID_USER10,

  MENU_ID_HELP_GENERAL,
  MENU_ID_HELP_README,
  MENU_ID_HELP_CONTEXT,
  MENU_ID_HELP_ABOUT,

  MAX_MENU_ID
};

#endif
